<template>
    <el-dialog :title="titleMap[mode]" v-model="visible" :width="660" destroy-on-close @closed="$emit('closed')" :close-on-click-modal="false" :close-on-press-escape="false">
        <el-form ref="dialogForm" :model="formData" :rules="rules" label-width="100px" label-position="top">
            <el-form-item label="品类/商品名称" prop="name">
                <el-input v-model="formData.name" clearable placeholder="请输入"></el-input>
                <div class="el-form-item-msg"></div>
            </el-form-item>
            <el-form-item label="默认成本" prop="price">
                <el-input v-model="formData.price" clearable placeholder="请输入">
                    <template #append>元</template>
                </el-input>
                <div class="el-form-item-msg"></div>
            </el-form-item>
            <el-form-item label="状态" prop="status">
                <el-radio-group v-model="formData.status">
                    <el-radio-button :label="1">正常</el-radio-button>
                    <el-radio-button :label="0">禁用</el-radio-button>
                </el-radio-group>
            </el-form-item>
        </el-form>
        <template #footer>
            <el-button @click="visible = false">取 消</el-button>
            <el-button type="primary" :loading="isSaveing" @click="submit()">提交</el-button>
        </template>
    </el-dialog>
</template>

<script>
export default {
    data(){
        return {
            loading: false,
            mode:"add",
            titleMap:{
                add:"新增品类/商品",
                edit:"编辑品类/商品"
            },
            rules:{
                name: [
                    {required: true, message: '请输入'}
                ],
                status: [
                    {required: true, message: '请选择'}
                ],
            },
            visible: false,
            isSaveing: false,
            formData:{},
        }
    },
    methods:{
        open(mode = 'add'){
            this.mode = mode;
            this.visible = true;
            return this
        },
        //表单注入数据
        setData(data){
            this.formData = data;
        },
        async submit(){
            var validate = await this.$refs.dialogForm.validate().catch(()=>{});
            if(!validate){ return false }
            let submitData = JSON.parse(JSON.stringify(this.formData));
            this.isSaveing = true;
            var resp = await this.$API.washGoods.save.post(submitData);
            this.isSaveing = false;
            if (resp.code == 0) {
                return this.$message.error(resp.msg);
            }
            this.$message.success(resp.msg);
            this.formData = {};
            this.visible = false;
            this.$emit("success");
        }
    }
}
</script>
